<?php

/**
 * rvc_nov_contra_val_mens actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage rvc_nov_contra_val_mens
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class rvc_nov_contra_val_mensActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'RVC_NOV_CONTRA_VAL_MENS',
        'RVC_CONTRATO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'RVC_CONTRATO_V' =>
        array(
            'id_contrato' => 'RVC_NOV_CONTRA_VAL_MENS'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'RVC_NOV_CONTRA_VAL_MENS' =>
        array(
            'id' => 'id',
            'id_contrato' => 'id_contrato',
            'valor_mensualizado_old' => 'valor_mensualizado_old',
            'valor_mensualizado_new' => 'valor_mensualizado_new',
            'observacion' => 'observacion',
            'usuario_log' => 'usuario_log',
            'fecha_log' => 'fecha_log'
        ),
        'RVC_CONTRATO_V' =>
        array(
            'num_contrato' => 'numero_contrato'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id DESC'
    ); //campos para el ordenamiento de la consulta


    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'RVC_NOV_CONTRA_VAL_MENS' =>
        array(
            'id,a' => array('!=' => array(-1)),
            'id,b' => array('=' => array('id')),
            'id_contrato' => array('=' => array('id_contrato')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
//    protected $query_qualifier = 'DISTINCT'; //Para eliminar filas repetidas

    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id'; //identificador de la tabla
    protected $id_names = array('id'); //llave primaria
    protected $field_names = array('id_contrato', 'valor_mensualizado_new', 'valor_mensualizado_old', 'observacion', 'usuario_log', 'fecha_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'RVC_NOV_CONTRA_VAL_MENS'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia    
    protected $has_secuencia = false; //si posee secuencia la tabla

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id'; //identificador unico de la tabla

    // Validate

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        $request['usuario_log'] = $request['id_username'];
        $request['fecha_log'] = CN_TABLE::fechaSistema();

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        $request['usuario_log'] = $request['id_username'];
        $request['fecha_log'] = CN_TABLE::fechaSistema();

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */

        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        //accion add
        $valor_mensualizado = $list_data_post[0]['valor_mensualizado_new'];
        $id_contrato = $list_data_post[0]['id_contrato'];

        if ($Action == "ADD") {

            $sql = "UPDATE RVC_CONTRATO
            SET VALOR_MENSUALIZADO = " . $valor_mensualizado . "
            WHERE ID_CONTRATO = " . $id_contrato;

            $records = CN_TABLE::executeSQL($sql);

            //Se actualiza sueldo de TERCEROS - 20220107::LAVILA
            $sql = <<<EOD
UPDATE TERCEROS
SET SUELDO = $valor_mensualizado 
WHERE 
to_char(NITOCC) = (select num_doc from rvc_contratista where id_contratista in 
    (SELECT    id_contratista FROM rvc_contrato     where id_contrato = $id_contrato)
)
EOD;

            $records = CN_TABLE::executeSQL($sql);
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }
        $this->conn->commit();
        return $request;
    }

}
